unit AddBookDialog;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, BookLibrary;

type
  TAddBookForm = class(TForm)
    Edit1: TEdit;
    Edit3: TEdit;
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Edit4: TEdit;
    Label4: TLabel;
    ComboBox1: TComboBox;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Edit3Change(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
  public
  end;

var
  AddBookForm: TAddBookForm;
implementation
{$R *.dfm}
uses Main;

procedure TAddBookForm.Button1Click(Sender: TObject);
begin
 AddBook( Edit1.Text, ComboBox1.Text, Edit4.Text, Edit3.Text  );
 BookLibrary.LibraryForm.ExecuteLibrary;
 Close;
end;

procedure TAddBookForm.Button2Click(Sender: TObject);
begin
 if MainForm.OpenDialog1.Execute then
  if FileExists( MainForm.OpenDialog1.FileName ) then
   Edit3.Text := MainForm.OpenDialog1.FileName;
end;

procedure TAddBookForm.Edit3Change(Sender: TObject);
begin
 Edit1.Text := ExtractFileName( Edit3.Text );
end;

procedure TAddBookForm.FormActivate(Sender: TObject);
var
 count : integer;
begin
 Edit1.Clear;
 ComboBox1.Clear;
 Edit3.Clear;
 Edit4.Clear;
 Button2.SetFocus;

 for count := 0 to Books[autor].Count-1 do
  if ( Books[autor][count]<>'' )
     and
     ( ComboBox1.Items.IndexOf( Books[autor][count] ) = -1 ) then
   ComboBox1.Items.Add( Books[autor][count] );
end;

procedure TAddBookForm.Button3Click(Sender: TObject);
begin
 Close;
end;

end.
