//------------------------------------------------------------------------------
// Project Rabbit II unit AddDictionaryDialog
// Open Source FreeWare
// http://wtwsoft.narod.ru/build.htm
// original download from http://wtwsoft.narod.ru
//------------------------------------------------------------------------------
//          ,
//    ,      ,  
//         .
//      ,  CreateObjects  TAddDictionaryForm

unit AddDictionaryDialog; //  

interface //  ,           

uses //  
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Config, Help;

type
  //    
  TAddDictionaryForm = class(TForm)
    procedure CreateObjects; //     
    procedure AdjustCaptions;//     
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
  private
  public
    Edit1,           //        
    Edit2 : TEdit;   //          
    Button1,         //  
    Button2,         //  
    Button3,         //      
    Button4 : TButton;//    
    Label1, Label2 : TLabel;
    CheckBox1: TCheckBox;// ,        
    RichEdit1: TRichEdit;//            
  end;

var
  AddDictionaryForm: TAddDictionaryForm; //   TAddDictionaryForm

//            
procedure ShowAddDictionaryDialog;

implementation //  
uses
 Dictionary, Main; //    ,        
{$R *.dfm} //    ,       TAddDictionaryForm,
           //   Delphi

//        
procedure ShowAddDictionaryDialog;
begin
 Application.CreateForm(TAddDictionaryForm, AddDictionaryForm); //     ,
  with AddDictionaryForm do // AddDictionaryForm   nil        TAddDictionaryForm
   begin //  
    BorderStyle := bsDialog; //      - ,    
    Position    := poMainFormCenter;//     
    Width  := 300;//   
    Height := 225;//   
    CreateObjects;//       
    AdjustCaptions;//       
    ShowModal;//    ,        
   end;
end;
//      
procedure TAddDictionaryForm.CreateObjects;
begin
//    
  RichEdit1 := TRichEdit.Create( AddDictionaryForm );//   RichEdit1
  RichEdit1.Parent := AddDictionaryForm; //  () 
  RichEdit1.Left  := 10; //     
  RichEdit1.Top   := 15;
  RichEdit1.Width := 280;
  RichEdit1.Height:= 40;
  RichEdit1.WordWrap := true; //   
  RichEdit1.BorderStyle := bsNone; //  
  RichEdit1.Color    := clBtnFace; //   (    )
  RichEdit1.ReadOnly := True; //  

//      
  Label1 := TLabel.Create( AddDictionaryForm );//  
  Label1.Parent := AddDictionaryForm;//  
  Label1.Left   := 10;//  ,  
  Label1.Top    := 75 + 5;
  Label1.Width  := 60;
//     
  Edit1 := TEdit.Create( AddDictionaryForm );
  Edit1.Parent := AddDictionaryForm;
  Edit1.Left  := 80;
  Edit1.Top   := 75;
  Edit1.Width := 200 ;  // 300 - 80 - 20
//       
  Label2 := TLabel.Create( AddDictionaryForm );
  Label2.Parent := AddDictionaryForm;
  Label2.Left   := 10;
  Label2.Top    := 105 + 5;
  Label2.Width  := 60;
  Label2.Font.Style := [fsBold];//    
// 
  Edit2 := TEdit.Create( AddDictionaryForm );
  Edit2.Parent := AddDictionaryForm;
  Edit2.Left  := 80;
  Edit2.Top   := 105;
  Edit2.Width := 180; // 300 - 80 - 20 - 20
  Edit2.OnChange := Edit2Change; //      
//         
  Button3 := TButton.Create( AddDictionaryForm );
  Button3.Parent := AddDictionaryForm;
  Button3.Left   := 260; // 300 - 20 - 20
  Button3.Top    := 105;
  Button3.Height := 20;
  Button3.Width  := 20;
  Button3.Caption := '...'; //   
  Button3.Font.Style := [fsBold];//   
  Button3.OnClick := Button3Click;//      
  Button3.TabOrder := 0;//       
//   
  CheckBox1 := TCheckBox.Create( AddDictionaryForm );
  CheckBox1.Parent := AddDictionaryForm;
  CheckBox1.Left := 10;
  CheckBox1.Top  := 135;
  CheckBox1.Width:= 280;
  CheckBox1.Checked := True;
//  
  Button1 := TButton.Create( AddDictionaryForm );
  Button1.Parent := AddDictionaryForm;
  Button1.Left   := 45; // 300 - 75 - 75 - 5 - 20 - 80
  Button1.Top    := 165;
  Button1.Width  := 75;
  Button1.Font.Style := [fsBold];//   
  Button1.OnClick:= Button1Click;//   
//  
  Button2 := TButton.Create( AddDictionaryForm );
  Button2.Parent := AddDictionaryForm;
  Button2.Left   := 125; // 135 + 5 + 75 - 80
  Button2.Top    := 165;
  Button2.Width  := 75;
  Button2.OnClick:= Button2Click;
//  
  Button4 := TButton.Create( AddDictionaryForm );
  Button4.Parent := AddDictionaryForm;
  Button4.Left   := 205; // 135 + 5 + 75
  Button4.Top    := 165;
  Button4.Width  := 75;
  Button4.OnClick:= Button4Click;
end;
//     ,    
//    GetLConf  config,   
//       
procedure TAddDictionaryForm.AdjustCaptions;
begin
 Caption := GetLConf('AddDictionaryCaption'); //    
 Label1.Caption := GetLConf('AddDictionaryDescription');
 Label2.Caption := GetLConf('AddDictionaryFileName');
 CheckBox1.Caption := GetLConf('AddDictionaryEnabled');
 Button1.Caption := GetLConf('AddDictionaryOKButton');
 Button2.Caption := GetLConf('AddDictionaryCancelButton');
 Button4.Caption := GetLConf('AddDictionaryHelpButton');
 RichEdit1.Lines.LoadFromFile( StartDir + '\help\' + 'AddDictionary.txt' )
end;
//    
procedure TAddDictionaryForm.Button1Click(Sender: TObject);
begin
//            Dictionary
// AddDictionary( Edit1.Text, Edit2.Text, booltostr(CheckBox1.Checked ));
 Close;//   
end;
//     
procedure TAddDictionaryForm.Button3Click(Sender: TObject);
begin
 MainForm.OpenDialog1.Execute;//     
 if FileExists( MainForm.OpenDialog1.FileName ) then//        
   Edit2.Text := MainForm.OpenDialog1.FileName;//        
end;
//   
procedure TAddDictionaryForm.Button2Click(Sender: TObject);
begin
 Close; //  
end;
//      
procedure TAddDictionaryForm.Edit2Change(Sender: TObject);
begin
//    
 if Edit2.Text = '' then Button1.Enabled := false //   
                    else Button1.Enabled := true; //     
//     
 if Edit1.Text = '' then  Edit1.Text := ExtractFileName(Edit2.Text);//        
end;
//   
procedure TAddDictionaryForm.Button4Click(Sender: TObject);
begin
//      Help
 GetHelp('AddDictionaryHelp'); //       AddDictionaryHelp
end;

end.
