//------------------------------------------------------------------------------
// Project Rabbit II unit Main
// Open Source FreeWare
// http://wtwsoft.narod.ru/build.htm
// original download from http://wtwsoft.narod.ru
//   ,     
//------------------------------------------------------------------------------
//        Delphi 7
// TSAPI/TSAPI.BPL,  !compile_component.bat
//------------------------------------------------------------------------------
unit Main;
interface
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,  Dialogs,
  Menus, StdCtrls, ComCtrls, ExtCtrls, Speech4, View, Buttons, ToolWin,
  ImgList,Config,ShellAPI,Help,NoSAPI,SAPI4, About;
const

  ProjectName = 'Rabbit II';  //  
  RVersion = '2.00.28';
  RBuild='28';


//         ,   
// StatusBar     0
  ssRead  : string = 'Reading...'; //   
  ssPause : string = 'Paused...';  //   
  ssStop  : string = 'Stoped...';  //  
  ssError : string = 'Error...';   //  
// AutoSave MainForm properties
 AutoSave  : boolean = true;
type
  TMainForm = class(TForm)
    Timer1: TTimer; //    
    procedure BuildMainForm;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);

    procedure CreateObjects;
    procedure AdjustCaptions;
    procedure LinkEvents;
    procedure OpenFile( FileName : string );

    procedure OpenFileClick(Sender: TObject);
    procedure CloseFileClick(Sender: TObject);
    procedure ExitRabbitClick(Sender: TObject);
    procedure SelectEngineClick(Sender: TObject);

    procedure BoldFontClick(Sender: TObject);
    procedure NormalFontClick(Sender: TObject);
    procedure ItalicFontClick(Sender: TObject);
    procedure UnderlineFontClick(Sender: TObject);
    procedure WordWrapTextClick(Sender: TObject);
    procedure SizeUpFontClick(Sender: TObject);
    procedure SizeDownFontClick(Sender: TObject);

    procedure ReadTextClick(Sender: TObject);
    procedure PauseTextClick(Sender: TObject);
    procedure StopTextClick(Sender: TObject);

    procedure Speech1StartEvent(Sender: TObject);
    procedure Speech1StopEvent(Sender: TObject);
    procedure Speech1PauseEvent(Sender: TObject);
    procedure Speech1ErrorEvent(Sender: TObject; Code: Integer;  Message: String);
    procedure Speech1WarningEvent(Sender: TObject; Code: Integer;  Message: String);
    procedure Speech1VisualEvent(Sender: TObject; Hints: Cardinal;Mouth: PTTSMouth);

    procedure ComboBox1Change(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure CheckBox1Change(Sender: TObject);

    procedure ScrollBar1Change(Sender: TObject);
    procedure ScrollBar2Change(Sender: TObject);
    procedure ScrollBar3Change(Sender: TObject);

    procedure SpeedUp1Click(Sender: TObject);
    procedure SpeedDown1Click(Sender: TObject);
    procedure VolumeUp1Click(Sender: TObject);
    procedure VolumeDown1Click(Sender: TObject);
    procedure PitchUp1Click(Sender: TObject);
    procedure PitchDown1Click(Sender: TObject);
    procedure SpeechPanel1Click(Sender: TObject);
    procedure Size81Click(Sender: TObject);
    procedure Size121Click(Sender: TObject);
    procedure Size141Click(Sender: TObject);
    procedure Size181Click(Sender: TObject);
    procedure Size241Click(Sender: TObject);
    procedure Normal2Click(Sender: TObject);
    procedure Normal3Click(Sender: TObject);
    procedure Normal4Click(Sender: TObject);
    procedure SetDefaultClick(Sender: TObject);

    procedure EngineDialogAboutClick(Sender: TObject);
    procedure EngineDialogLexiconClick(Sender: TObject);
    procedure EngineDialogTranslateClick(Sender: TObject);
    procedure EngineDialogGeneralClick(Sender: TObject);

    procedure FontDialog1Click(Sender: TObject);
    procedure ColorDialog1Click(Sender: TObject);

    procedure SpeechPanelTop1Click(Sender: TObject);
    procedure SpeechPanelBottomClick(Sender: TObject);
    procedure StartReadText;
    procedure ReadingText;
    procedure ShowDictonaryClick(Sender: TObject);
    procedure AboutRabbitClick(Sender: TObject);
    procedure ShowHint(Sender: TObject);
    procedure ChengLangClick(Sender: TObject);

    procedure ShowHelpBook(Sender: TObject);
    procedure ShowWebSite(Sender: TObject);

    procedure LibraryAdd(Sender: TObject);
    procedure LibraryAddNew(Sender: TObject);
    procedure LibraryShow(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);

    procedure StartEnabled( flag : boolean );
    procedure PauseEnabled( flag : boolean );
    procedure StopEnabled( flag : boolean );
    procedure BitBtn1Click(Sender: TObject);
  private
    function CreateMenuItem( var MenuItem : TMenuItem; Caption, ShortCut, Hint : string ):TMenuItem;overload;
    function CreateMenuItem( var MenuItem : TMenuItem; ConfigKey : string ):TMenuItem;overload;

  public

   StatusBar1 : TStatusBar;
   MainMenu1: TMainMenu;
   OpenDialog1: TOpenDialog;
   FontDialog1:TFontDialog;
   ColorDialog1:TColorDialog;
   Speech1: TSpeech;
   Panel3: TPanel;
   ImageList1 : TImageList;
   ToolBar1,
   ToolBar2: TToolBar;

   ToolButton1, ToolButton2,
   ReadButton, PauseButton, StopButton,
   ToolButton6,
   ToolButton7 : TToolButton;

   ComboBox1,
   ComboBox2: TComboBox;
   CheckBox1:TCheckBox;
   Button1:TButton;

   Label1, Label2, Label3, Label4,
   Label5, Label6, Label7: TLabel;

   ScrollBar1, ScrollBar2, ScrollBar3: TScrollBar;

   Bevel1, Bevel2: TBevel;

   FilesItem,
    OpenFileItem,
    CloseFileItem,
    LangItem,
      LangsItems,
    ExitRabbitItem,
   LibraryItem,
    LibraryAddItem,
    LibraryAddNewItem,
    LibraryShowItem,
   ViewItem,
    FontItem,
     FontStyleItem,
      BoldFontItem,
      NormalFontItem,
      ItalicFontItem,
      UnderlineFontItem,
     SizeFontItem,
      Size81,
      Size121,
      Size141,
      Size181,
      Size241,
      SizeUpFontItem,
      SizeDownFontItem,
    FontDialogItem,
    WordWrapTextItem,
    ColorDialogItem,
    SetDefaultItem,
   SpeechItem,
    ReadText,
    PauseReadText,
    StopReadText,
    Speed1,
     SpeedUp1,
     Normal2,
     SpeedDown1,
    Volume1,
     VolumeUp1,
     Normal3,
     VolumeDown1,
    Pitch1,
     PitchUp1,
     Normal4,
     PitchDown1,
    SpeechPanelItem,
    SpeechPanelAlignItem,
     SpeechPanelTopItem,
     SpeechPanelBottomItem,
    EngineDialogsItem,
     EngineDialogAboutItem,
     EngineDialogLexiconItem,
     EngineDialogTranslateItem,
     EngineDialogGeneralItem,
     DictionItem,
   WindowsItem,
   HelpItem,
    HelpBookItem,
    WebItem,
    AboutItem,
   N3,N1,N4,N5,N6: TMenuItem;
   WaitOnStopRead, AbortReading  : boolean;
   OpenFiles : TStringList;

    SymbolCount:integer; //  

    s : string; // -       
    s1 : string;// 

    UsingReadAlgoritm : byte;
    UsingDictionary   : boolean;
     i, reallength: integer; //       
     basy : boolean;
  end;

var
  MainForm: TMainForm;

//brul
t,t2 : integer;
FlagReading : boolean = false;
FlagStop : boolean = true;
FlagTextBufferIsReady : boolean = false;
FlagEndOfText : boolean = false;
TextBufer : string = '';

 s,s2 : string;
 sl : TStringList;

implementation
{$R *.dfm}
uses Dictionary, BookLibrary, AddBookDialog;
//RC5

procedure TMainForm.BuildMainForm;
begin
   Application.Title := ProjectName;
   //    ,     ,   
   Color     := clAppWorkSpace;   //  
   FormStyle := fsMDIForm;        //      MDI  
   Caption   := ProjectName;
   Constraints.MinHeight := 450;  //   
   Constraints.MinWidth  := 410;
   if AutoSave then               //   
    begin
     Width  := StrToInt(GetMConf('MainWidth')); //    .         
     Height := StrToInt(GetMConf('MainHeight'));
     Top    := StrToInt(GetMConf('MainTop'));
     Left   := StrToInt(GetMConf('MainLeft'));
   end;
   CreateObjects;
   CloseFileItem.Enabled  := false; //    Files\Close ,  ,      
   BoldFontItem.Enabled   := false; //    wiev\font\bold
   NormalFontItem.Enabled := false; //   
   ItalicFontItem.Enabled := false;
   ViewItem.Enabled       := false;
   WindowsItem.Enabled    := false;
   ReadText.Enabled       := false;
   StopReadText.Enabled   := false;
   PauseReadText.Enabled  := false;

   ReadButton.Enabled  := false;
   PauseButton.Enabled := false;
   StopButton.Enabled  := false;

   LinkEvents;
   //   ,  SAPI ,    .
   //     
   if Speech1.Engines.Count > 0 then
    begin
     ComboBox1.Items.Assign( Speech1.Engines );  //    SAPI   Items ComboBox1  Panel3
     ComboBox1.ItemIndex := 0;      //         
     Speech1.SelectEngine( Speech1.Engines[0] ); //        

     //   (ScrollBar)    ( Panel3)
     try
     ScrollBar1.Min := Speech1.Info.MinSpeed; //   
     ScrollBar1.Max := Speech1.Info.MaxSpeed; //   
     ScrollBar2.Min := Speech1.Info.MinVolume;//  ,    ,   ,  
     ScrollBar2.Max := Speech1.Info.MaxVolume;
     ScrollBar3.Min := Speech1.Info.MinPitch; //  ,     ,   ,  
     ScrollBar3.Max := Speech1.Info.MaxPitch;
     ScrollBar1.Position := StrToInt(GetMConf('SpeechSpeed'));
     ScrollBar2.Position := StrToInt(GetMConf('SpeechVolume'));
     ScrollBar3.Position := StrToInt(GetMConf('SpeechPitch'));
     except
     end;

    end
   else
    begin
     ComboBox1.Enabled  := false;
     ScrollBar1.Enabled := false;
     ScrollBar2.Enabled := false;
     ScrollBar3.Enabled := false;
    end;

  StopEnabled( false );
  PauseEnabled( false );
  StartEnabled( true );

end;

function TMainForm.CreateMenuItem( var MenuItem : TMenuItem; Caption, ShortCut, Hint : string ):TMenuItem;
begin
 MenuItem := TMenuItem.Create( Self ); //    
 MenuItem.Caption := Caption; //  
 MenuItem.ShortCut := TextToShortCut( ShortCut ); //    
 MenuItem.Hint := Hint;
 CreateMenuItem := MenuItem; //       
end;

function TMainForm.CreateMenuItem( var MenuItem : TMenuItem; ConfigKey : string ):TMenuItem;
begin
 if MenuItem = nil then MenuItem := TMenuItem.Create( Self );
 MenuItem.Caption := GetLConf( ConfigKey );
 MenuItem.Hint    := GetLConf( ConfigKey + '_h');
 MenuItem.ShortCut:= TextToShortCut( GetMConf( ConfigKey + '_sc'));
 if MenuItem.Caption <> '' then
  if MenuItem.Caption[1]='/' then MenuItem.Visible := false;
 CreateMenuItem := MenuItem;
end;
//       
//         
//           LinkEvents
procedure TMainForm.CreateObjects;
var
 StatusPannel : TStatusPanel; //       StatusBar
 Image  : TImage; //       ImageList
 Count : integer;
 LangStr : string;

 procedure LoadPicture( FileName : string );
 begin
  Image.Canvas.FillRect(Image.Canvas.ClipRect );
  if FileExists( FileName ) then Image.Picture.LoadFromFile( FileName );
  ImageList1.Add(Image.Picture.Bitmap,Image.Picture.Bitmap);
 end;

 procedure CreateToolButton(var ToolButton : TToolButton; ImIndex : integer );
 begin
  ToolButton := TToolButton.Create( Self ); //  
  ToolButton.Parent     := ToolBar1;
  if ImIndex > -1 then
   begin
    ToolButton.ImageIndex := ImIndex;
   end
  else
   begin
    ToolButton.Style := tbsSeparator;
    ToolButton.Width := 5;
   end;
 end;

begin

  MainForm.Color := clAppWorkSpace;
  MainForm.FormStyle := fsMDIForm;

  StatusBar1 := TStatusBar.Create( Self );//  ,    ,      TStatusBar   Self (-)
  StatusBar1.Parent := MainForm;
//RC20,RC2
  StatusPannel := StatusBar1.Panels.Add; //      StatusBar1
  StatusPannel.Width := 100;
  StatusPannel.Alignment := taCenter;    //   -     

  StatusPannel := StatusBar1.Panels.Add; //    
  StatusPannel.Alignment := taCenter;    //   
  StatusPannel.Width := 75;
  StatusPannel := StatusBar1.Panels.Add; //    
  StatusPannel.Alignment := taCenter;    //   
  StatusPannel.Width := 75;
  StatusPannel := StatusBar1.Panels.Add; //    
  StatusPannel.Alignment := taCenter;    //   
  StatusPannel.Width := 75;

  StatusPannel := StatusBar1.Panels.Add; //  ,  :   
                                         //   ,       Add      
                                         //     ,      .
  StatusPannel.Alignment := taCenter;    // 
  StatusPannel.Width := 100;
  StatusPannel := StatusBar1.Panels.Add; //  
  StatusPannel.Alignment := taCenter;    // ,        ,  StatusBar, Add  
                                         //    StatusPanel
  OpenDialog1:= TOpenDialog.Create(Self);//       Windows   
                                         //    -   ,        
  FontDialog1:= TFontDialog.Create(Self);//     
  ColorDialog1:= TColorDialog.Create(Self);
//   ImageList       ToolBar  MainMenu
  ImageList1 := TImageList.Create(Self); //  ,  ,
  ImageList1.Width  := 20;               //       . RC3
  ImageList1.Height := 20;

  Image := TImage.Create( Self );        //  Image,    
   LoadPicture( StartDir + '\resourse\1.bmp');
   LoadPicture( StartDir + '\resourse\2.bmp');
   LoadPicture( StartDir + '\resourse\3.bmp');
   LoadPicture( StartDir + '\resourse\4.bmp');
   LoadPicture( StartDir + '\resourse\5.bmp');
   LoadPicture( StartDir + '\resourse\6.bmp');
  Image.Destroy;                        //     
//RC4
  Panel3 := TPanel.Create(Self);         //  
  Panel3.Parent := MainForm;             //    
  Panel3.Height := 85;                   //  
  Panel3.Top    := 15;                   // RC21
  Panel3.Align  := alTop;                //  -  
  Panel3.BevelInner := bvRaised;         //  
  Panel3.BevelOuter := bvLowered;        //   
  Panel3.Visible := StrToBool(GetMConf('SpeechPanel'));
//RC23
  ComboBox1:= TComboBox.Create(Self);    //  ComboBox1
  ComboBox1.Parent:= Panel3;             //       Panel3
  ComboBox1.Font.Style := [fsBold];
  ComboBox1.Top   := 16;                 //  
  ComboBox1.Left  := 5;
  ComboBox1.Width := 160;
  ComboBox1.Style := csDropDownList;

  ComboBox2:= TComboBox.Create(Self);    //  ComboBox1
  ComboBox2.Parent:= Panel3;             //       Panel3
  ComboBox2.Top   := 38;                 //  
  ComboBox2.Left  := 5;
  ComboBox2.Width := 160;
  ComboBox2.Style := csDropDownList;


  CheckBox1:= TCheckBox.Create(Self);
  CheckBox1.Parent:=Panel3;
  CheckBox1.Top   := 63;
  CheckBox1.Left  := 5;
  CheckBox1.Width := 100;
  CheckBox1.Checked := StrToBool(GetMConf('UseDictionary'));

  Button1 := TButton.Create(Self);
  Button1.Parent  := Panel3;
  Button1.Top   := 63;
  Button1.Left  := 114;
  Button1.Width := 50;
  Button1.Height:= 18;
  Button1.Font.Style := [fsBold];
  Button1.Enabled := false;

//    
  Label1 := TLabel.Create(Self);
  Label1.Parent := Panel3;
  Label1.Top   := 11;
  Label1.Left  := 179;

 Label2 := TLabel.Create(Self);
 Label2.Parent := Panel3;
 Label2.Top   := 30;
 Label2.Left  := 179;

 Label3 := TLabel.Create(Self);
 Label3.Parent := Panel3;
 Label3.Top   := 49;
 Label3.Left  := 179;

 Label4 := TLabel.Create(Self);
 Label4.Parent := Panel3;
 Label4.Top   := 3;
 Label4.Left  := 7;
 Label4.Font.Style := [fsBold];

 Label5 := TLabel.Create(Self);
 Label5.Parent := Panel3;
 Label5.Top   := 11;
 Label5.Left  := 370;
 Label5.Caption := '0';

 Label6 := TLabel.Create(Self);
 Label6.Parent := Panel3;
 Label6.Top   := 30;
 Label6.Left  := 370;
 Label6.Caption := '0';

 Label7 := TLabel.Create(Self);
 Label7.Parent := Panel3;
 Label7.Top   := 49;
 Label7.Left  := 370;
 Label7.Caption := '0';

//   , ,   
 ScrollBar1 := TScrollBar.Create(Self);
 ScrollBar1.Parent := Panel3;
 ScrollBar1.Top  := 9;
 ScrollBar1.Left := 240;
 ScrollBar1.Width := 121;

 ScrollBar2 := TScrollBar.Create(Self);
 ScrollBar2.Parent := Panel3;
 ScrollBar2.Top  := 28;
 ScrollBar2.Left := 240;
 ScrollBar2.Width := 121;

 ScrollBar3 := TScrollBar.Create(Self);
 ScrollBar3.Parent := Panel3;
 ScrollBar3.Top  := 47;
 ScrollBar3.Left := 240;
 ScrollBar3.Width := 121;

//    ,   
 Bevel1 := TBevel.Create(Self);
 Bevel1.Parent := Panel3;
 Bevel1.Top   := 2;
 Bevel1.Left  := 169;
 Bevel1.Width := 2;
 Bevel1.Height:= 80;

 Bevel2 := TBevel.Create(Self);
 Bevel2.Parent := Panel3;
 Bevel2.Top   := 2;
 Bevel2.Left  := 400;
 Bevel2.Width := 2;
 Bevel2.Height:= 80;
//  MainMenu,     CreateMenuItem   
  MainMenu1 := TMainMenu.Create(Self); //   ,  
//         (  ,    )
//RC6
   MainMenu1.Items.Add( CreateMenuItem( FilesItem,'Files')); //     Files
    FilesItem.Add(CreateMenuItem( OpenFileItem,'FilesOpen'));//    Files,  /Open
    FilesItem.Add(CreateMenuItem( CloseFileItem,'FilesClose'));
    FilesItem.Add(CreateMenuItem( LangItem,'FileLang'));
    FilesItem.Add(CreateMenuItem( N1,'-','',''));
    FilesItem.Add(CreateMenuItem( ExitRabbitItem,'FilesExit'));
   MainMenu1.Items.Add( CreateMenuItem(LibraryItem,'Library'));
    LibraryItem.Add(CreateMenuItem( LibraryAddItem,'LibraryAdd'));
    LibraryItem.Add(CreateMenuItem( LibraryAddNewItem,'LibraryNewAdd'));
    LibraryItem.Add(CreateMenuItem( LibraryShowItem,'LibraryShow'));
   MainMenu1.Items.Add( CreateMenuItem( ViewItem,'View'));
    ViewItem.Add(CreateMenuItem( FontItem,'ViewFont'));
     FontItem.Add(CreateMenuItem( FontStyleItem,'ViewFontStyle'));
      FontStyleItem.Add(CreateMenuItem( BoldFontItem,'ViewFontStyleBold'));
      FontStyleItem.Add(CreateMenuItem( NormalFontItem,'ViewFontStyleNormal'));
      FontStyleItem.Add(CreateMenuItem( ItalicFontItem,'ViewFontStyleItalic'));
      FontStyleItem.Add(CreateMenuItem( UnderlineFontItem,'ViewFontStyleUnderline'));
     FontItem.Add(CreateMenuItem( SizeFontItem,'ViewFontSize'));
      SizeFontItem.Add(CreateMenuItem( SizeUpFontItem,'ViewFontSizeUp'));
      SizeFontItem.Add(CreateMenuItem( SizeDownFontItem,'ViewFontSizeDown'));
      SizeFontItem.Add(CreateMenuItem( N3,'-','',''));
      SizeFontItem.Add(CreateMenuItem( Size81,'ViewFontSize8'));
      SizeFontItem.Add(CreateMenuItem( Size121,'ViewFontSize12'));
      SizeFontItem.Add(CreateMenuItem( Size141,'ViewFontSize14'));
      SizeFontItem.Add(CreateMenuItem( Size181,'ViewFontSize18'));
      SizeFontItem.Add(CreateMenuItem( Size241,'ViewFontSize24'));
    ViewItem.Add(CreateMenuItem( FontDialogItem,'ViewFontDialog'));
    ViewItem.Add(CreateMenuItem( N3,'-','',''));
    ViewItem.Add(CreateMenuItem( WordWrapTextItem,'ViewWordWrap'));
    ViewItem.Add(CreateMenuItem( ColorDialogItem,'ViewColorDialog'));
    ViewItem.Add(CreateMenuItem( N3,'-','',''));
    ViewItem.Add(CreateMenuItem( SetDefaultItem,'ViewSetDefault'));
   MainMenu1.Items.Add( CreateMenuItem( SpeechItem,'Speech'));
    SpeechItem.Add(CreateMenuItem( ReadText,'SpeechRead'));
    SpeechItem.Add(CreateMenuItem( PauseReadText,'SpeechPause'));
    SpeechItem.Add(CreateMenuItem( StopReadText,'SpeechStop'));
    SpeechItem.Add(CreateMenuItem( N4,'-','',''));
    SpeechItem.Add(CreateMenuItem( Speed1,'SpeechSpeed'));
     Speed1.Add(CreateMenuItem( SpeedUp1,'SpeechSpeedUp'));
     Speed1.Add(CreateMenuItem( SpeedDown1,'SpeechSpeedDown'));
     Speed1.Add(CreateMenuItem( Normal2,'SpeechSpeedNormal'));
    SpeechItem.Add(CreateMenuItem( Volume1,'SpeechVolume'));
     Volume1.Add(CreateMenuItem( VolumeUp1,'SpeechVolumeUp'));
     Volume1.Add(CreateMenuItem( VolumeDown1,'SpeechVolumeDown'));
     Volume1.Add(CreateMenuItem( Normal3,'SpeechVolumeNormal'));
    SpeechItem.Add(CreateMenuItem( Pitch1,'SpeechPitch'));
     Pitch1.Add(CreateMenuItem( PitchUp1,'SpeechPitchUp'));
     Pitch1.Add(CreateMenuItem( PitchDown1,'SpeechPitchDown'));
     Pitch1.Add(CreateMenuItem( Normal4,'SpeechPitchNormal'));
    SpeechItem.Add(CreateMenuItem( N4,'-','',''));
    SpeechItem.Add(CreateMenuItem( SpeechPanelItem,'SpeechPanel'));
    SpeechItem.Add(CreateMenuItem( SpeechPanelAlignItem,'SpeechPanelAlign'));
     SpeechPanelAlignItem.Add(CreateMenuItem( SpeechPanelTopItem,'SpeechPanelAlignTop'));
     SpeechPanelAlignItem.Add(CreateMenuItem( SpeechPanelBottomItem,'SpeechPanelAlignBottom'));
    SpeechItem.Add(CreateMenuItem( N4,'-','',''));
    SpeechItem.Add(CreateMenuItem( EngineDialogsItem,'SpeechEngineDialog'));
     EngineDialogsItem.Add(CreateMenuItem(EngineDialogAboutItem,'SpeechEngineDialogAbout'));
     EngineDialogsItem.Add(CreateMenuItem(EngineDialogGeneralItem,'SpeechEngineDialogGeneral'));
     EngineDialogsItem.Add(CreateMenuItem(EngineDialogLexiconItem,'SpeechEngineDialogLexicon'));
     EngineDialogsItem.Add(CreateMenuItem(EngineDialogTranslateItem,'SpeechEngineDialogTranslate'));
    SpeechItem.Add(CreateMenuItem( DictionItem,'SpeechDiction'));
   MainMenu1.Items.Add( CreateMenuItem( WindowsItem,'Windows'));
   MainMenu1.Items.Add( CreateMenuItem( HelpItem,'Help'));
    HelpItem.Add( CreateMenuItem( HelpBookItem,'HelpBook'));
    HelpItem.Add( CreateMenuItem( WebItem,'HelpWebSite'));
    HelpItem.Add( CreateMenuItem( AboutItem,'HelpAbout'));

//    visual menu disign - pictures, bold e.t.c.
    OpenFileItem.Default := true;
    ImageList1.GetBitmap(0,OpenFileItem.Bitmap);
    ReadText.Default := true;
    ImageList1.GetBitmap(1,ReadText.Bitmap);
    ImageList1.GetBitmap(2,PauseReadText.Bitmap);
    ImageList1.GetBitmap(3,StopReadText.Bitmap);
    ImageList1.GetBitmap(4,SpeechPanelItem.Bitmap);

// create interface languge item
   for Count := 1 to 20 do
    begin
     LangStr := GetLConf('FileLang' + inttostr(Count));
     if LangStr[1]<>'%' then
      begin
       LangItem.Add(CreateMenuItem( LangsItems,LangStr,GetMConf('FileLang' + inttostr(Count)+'_sc'),GetLConf('FileLang' + inttostr(Count)+'_h')));
       if Count = CurentLang then LangsItems.Checked := true;
       LangsItems.OnClick := ChengLangClick;
      end;
    end;

//   ToolBar1,   ,     
//   ToolBar.
 ToolBar1 := TToolBar.Create(Self); //     
 ToolBar1.Parent := MainForm;       //  ToolBar  
 ToolBar1.Align  := alTop;          //      
 ToolBar1.Height := 32;
 ToolBar1.Top    := 0;
 ToolBar1.Images := ImageList1;    //  ToolBar,    
 ToolBar1.ParentColor := false;    //    
 ToolBar1.Color := clBtnFace;      //  

 ToolBar2 := TToolBar.Create(Self);
 ToolBar2.Parent := MainForm;
 ToolBar2.Align  := alBottom;
 ToolBar2.ParentColor := false;
 ToolBar2.Color := clBtnFace;
 ToolBar2.Flat := true;
 ToolBar2.Height := 28;
 ToolBar2.Images := ImageLIst1;
 ToolBar2.ShowCaptions := true;
 ToolBar2.List := true;
//   ,     ListImage,    ToolBar 
//     ToolButton
 CreateToolButton( ToolButton7, 4 );
 ToolButton7.Hint := GetLConf('SpeechPanel')+' ( '+GetMConf( 'SpeechPanel_sc')+' )';
 CreateToolButton( ToolButton6,-1 );
 CreateToolButton( StopButton, 3 );
 StopButton.Hint := GetLConf('SpeechStop')+' ( '+GetMConf( 'SpeechStop_sc')+' )';
 CreateToolButton( PauseButton, 2 );
 PauseButton.Hint := GetLConf('SpeechPause')+' ( '+GetMConf( 'SpeechPause_sc')+' )';
 CreateToolButton( ReadButton, 1 );
 ReadButton.Hint := GetLConf('SpeechRead')+' ( '+GetMConf( 'SpeechRead_sc')+' )';
 CreateToolButton( ToolButton2,-1 );
 CreateToolButton( ToolButton1, 0 );
 ToolButton1.Hint := GetLConf('FilesOpen')+' ( '+GetMConf( 'FilesOpen_sc')+' )';
//RC22
 AdjustCaptions;

 try
  Speech1:= TSpeech.Create(Self);
 except
 end;

 if not Speech4.FInit then NoSAPIForm.ShowModal;
 //!!!!!


end;

procedure TMainForm.AdjustCaptions;
begin
 CreateMenuItem( FilesItem,'Files');
 CreateMenuItem( OpenFileItem,'FilesOpen');
 CreateMenuItem( CloseFileItem,'FilesClose');
 CreateMenuItem( ExitRabbitItem,'FilesExit');
 CreateMenuItem(LibraryItem,'Library');
 CreateMenuItem( LibraryAddItem,'LibraryAdd');
 CreateMenuItem( LibraryAddNewItem,'LibraryNewAdd');
 CreateMenuItem( LibraryShowItem,'LibraryShow');
 CreateMenuItem( ViewItem,'View');
 CreateMenuItem( LangItem,'FileLang');
 CreateMenuItem( FontItem,'ViewFont');
 CreateMenuItem( FontStyleItem,'ViewFontStyle');
 CreateMenuItem( BoldFontItem,'ViewFontStyleBold');
 CreateMenuItem( NormalFontItem,'ViewFontStyleNormal');
 CreateMenuItem( ItalicFontItem,'ViewFontStyleItalic');
 CreateMenuItem( UnderlineFontItem,'ViewFontStyleUnderline');
 CreateMenuItem( SizeFontItem,'ViewFontSize');
 CreateMenuItem( SizeUpFontItem,'ViewFontSizeUp');
 CreateMenuItem( SizeDownFontItem,'ViewFontSizeDown');
 CreateMenuItem( Size81,'ViewFontSize8');
 CreateMenuItem( Size121,'ViewFontSize12');
 CreateMenuItem( Size141,'ViewFontSize14');
 CreateMenuItem( Size181,'ViewFontSize18');
 CreateMenuItem( Size241,'ViewFontSize24');
 CreateMenuItem( FontDialogItem,'ViewFontDialog');
 CreateMenuItem( WordWrapTextItem,'ViewWordWrap');
 CreateMenuItem( ColorDialogItem,'ViewColorDialog');
 CreateMenuItem( SetDefaultItem,'ViewSetDefault');
 CreateMenuItem( SpeechItem,'Speech');
 CreateMenuItem( ReadText,'SpeechRead');
 CreateMenuItem( PauseReadText,'SpeechPause');
 CreateMenuItem( StopReadText,'SpeechStop');
 CreateMenuItem( Speed1,'SpeechSpeed');
 CreateMenuItem( SpeedUp1,'SpeechSpeedUp');
 CreateMenuItem( SpeedDown1,'SpeechSpeedDown');
 CreateMenuItem( Normal2,'SpeechSpeedNormal');
 CreateMenuItem( Volume1,'SpeechVolume');
 CreateMenuItem( VolumeUp1,'SpeechVolumeUp');
 CreateMenuItem( VolumeDown1,'SpeechVolumeDown');
 CreateMenuItem( Normal3,'SpeechVolumeNormal');
 CreateMenuItem( Pitch1,'SpeechPitch');
 CreateMenuItem( PitchUp1,'SpeechPitchUp');
 CreateMenuItem( PitchDown1,'SpeechPitchDown');
 CreateMenuItem( Normal4,'SpeechPitchNormal');
 CreateMenuItem( SpeechPanelItem,'SpeechPanel');
 CreateMenuItem( SpeechPanelAlignItem,'SpeechPanelAlign');
 CreateMenuItem( SpeechPanelTopItem,'SpeechPanelAlignTop');
 CreateMenuItem( SpeechPanelBottomItem,'SpeechPanelAlignBottom');
 CreateMenuItem( EngineDialogsItem,'SpeechEngineDialog');
 CreateMenuItem(EngineDialogAboutItem,'SpeechEngineDialogAbout');
 CreateMenuItem(EngineDialogGeneralItem,'SpeechEngineDialogGeneral');
 CreateMenuItem(EngineDialogLexiconItem,'SpeechEngineDialogLexicon');
 CreateMenuItem(EngineDialogTranslateItem,'SpeechEngineDialogTranslate');
 CreateMenuItem( DictionItem,'SpeechDiction');
 CreateMenuItem( WindowsItem,'Windows');
 CreateMenuItem( HelpItem,'Help');
 CreateMenuItem( HelpBookItem,'HelpBook');
 CreateMenuItem( WebItem,'HelpWebSite');
 CreateMenuItem( AboutItem,'HelpAbout');

 Label2.Caption := GetLConf('lbVolume');
 Label1.Caption := GetLConf('lbSpeed');
 Label3.Caption := GetLConf('lbPitch');
 Label4.Caption := GetLConf('lbEngine');

 ComboBox2.Items.Clear;
 ComboBox2.Items.Add(GetLConf('ReadAlgoritm1'));
 ComboBox2.Items.Add(GetLConf('ReadAlgoritm2'));
 ComboBox2.ItemIndex := strtoint(GetMConf('ReadAlgoritm'))-1;
 CheckBox1.Caption := GetLConf('UseDictionary');
 Button1.Caption := GetLConf('SelButton');


 ssRead  := GetLConf('ssRead');
 ssPause := GetLConf('ssPause');
 ssStop  := GetLConf('ssStop');
 ssError := GetLConf('ssError');
end;
//      -  
//  ,      ,   
//  -    ,      TMainForm.
procedure TMainForm.LinkEvents;
var
 count : integer;
begin
 Application.OnHint := ShowHint;
 MainForm.OnClose    := MainForm.FormClose;
 ComboBox1.OnChange := ComboBox1Change; //     
 ComboBox2.OnChange := ComboBox2Change; //     
 CheckBox1.OnClick  := CheckBox1Change;
 Button1.OnClick    := SelectEngineClick; 
//   (ScrollBar) , , 
 ScrollBar1.OnChange := ScrollBar1Change; //   
 ScrollBar2.OnChange := ScrollBar2Change; // 
 ScrollBar3.OnChange := ScrollBar3Change; // 
//RC7
 OpenFileItem.OnClick       := OpenFileClick;  //   Files\Open     Open1Click
 ExitRabbitItem.OnClick     := ExitRabbitClick;
 CloseFileItem.OnClick      := CloseFileClick;
 BoldFontItem.OnClick       := BoldFontClick;  //  Font\Style\Bold  Bold1Click
 NormalFontItem.OnClick     := NormalFontClick;
 ItalicFontItem.OnClick     := ItalicFontClick;
 UnderlineFontItem.OnClick  := UnderlineFontClick;

 SizeUpFontItem.OnClick     := SizeUpFontClick;
 SizeDownFontItem.OnClick   := SizeDownFontClick;
 WordWrapTextItem.OnClick   := WordWrapTextClick;
 ReadText.OnClick      := ReadTextClick;
 PauseReadText.OnClick := PauseTextClick;
 StopReadText.OnClick  := StopTextClick;

 SpeedUp1.OnClick    := SpeedUp1Click;
 SpeedDown1.OnClick  := SpeedDown1Click;
 VolumeUp1.OnClick   := VolumeUp1Click;
 VolumeDown1.OnClick := VolumeDown1Click;
 PitchUp1.OnClick    := PitchUp1Click;
 PitchDown1.OnClick  := PitchDown1Click;
 SpeechPanelItem.OnClick:= SpeechPanel1Click;
 SpeechPanelTopItem.OnClick:=  SpeechPanelTop1Click;
 SpeechPanelBottomItem.OnClick:= SpeechPanelBottomClick;
 Size81.OnClick      := Size81Click;
 Size121.OnClick     := Size121Click;
 Size141.OnClick     := Size141Click;
 Size181.OnClick     := Size181Click;
 Size241.OnClick     := Size241Click;
 Normal2.OnClick     := Normal2Click;
 Normal3.OnClick     := Normal3Click;
 Normal4.OnClick     := Normal4Click;
 SetDefaultItem.OnClick := SetDefaultClick;

 EngineDialogAboutItem.OnClick     := EngineDialogAboutClick;
 EngineDialogLexiconItem.OnClick   := EngineDialogLexiconClick;
 EngineDialogTranslateItem.OnClick := EngineDialogTranslateClick;
 EngineDialogGeneralItem.OnClick   := EngineDialogGeneralClick;
 DictionItem.OnClick := ShowDictonaryClick;

 WebItem.OnClick          := ShowWebSite;
 HelpBookItem.OnClick     := ShowHelpBook;
 AboutItem.OnClick        := AboutRabbitClick;

 FontDialogItem.OnClick   := FontDialog1Click;
 ColorDialogItem.OnClick  := ColorDialog1Click;

 ToolButton7.OnClick  := SpeechPanel1Click;
 StopButton.OnClick   := StopTextClick;
 PauseButton.OnClick  := PauseTextClick;
 ReadButton.OnClick   := ReadTextClick;
 ToolButton1.OnClick  := OpenFileClick;  //   ,       


 Speech1.OnStart := Speech1StartEvent;
 Speech1.OnStop := Speech1StopEvent;
 Speech1.OnError := Speech1ErrorEvent;
 Speech1.OnWarning := Speech1WarningEvent;
 Speech1.OnVisual  := Speech1VisualEvent;

 LibraryAddItem.OnClick := LibraryAdd;
 LibraryAddNewItem.OnClick := LibraryAddNew;
 LibraryShowItem.OnClick := LibraryShow;


     OpenFiles := TStringList.Create;
 if FileExists( StartDir + '\' + ConfigFolder + '\' + 'opendocs.ini') then
  begin
   OpenFiles.LoadFromFile(StartDir + '\' + ConfigFolder + '\' + 'opendocs.ini');
   for count := 0 to OpenFiles.Count-1 do OpenFile( OpenFiles[count] );
  end;

end;

//        ,    
//      RichEdit,    , 
//  ""         "Windows"
procedure TMainForm.OpenFile( FileName : string );
var
 ShortCutCount, //         ,   0..10
 MenuItemCount : integer; //    "Windows",     
 NewItemShortCutStr : string; //         
                              //  
begin
 if FileExists( FileName ) then
  begin
   ViewForm := TViewForm.Create( MainForm.Owner );  //   ,      View
   ViewForm.LocalCreate;
   with ViewForm do //          with .. do
    begin
     Caption := ExtractFileName( FileName );  //     ()   
     RichEdit1.Lines.LoadFromFile( FileName );//     RichEdit.Lines,        


     IndexFileName := OpenFiles.IndexOf(FileName);
//RC8
     WindowsItem.Add(CreateMenuItem( WindowMenuItem,ExtractFileName( FileName ),'',''));//    Files,  /Open
     WindowMenuItem.OnClick := WindowMenuClick; //  - WindowMenuClick   OnClick   

     WindowToolButton := TToolButton.Create(Self);
     WindowToolButton.Parent := ToolBar2;
     WindowToolButton.Caption := WindowMenuItem.Caption + ' ';
     WindowToolButton.Down := true;
     WindowToolButton.ImageIndex := 5;
     WindowToolButton.OnClick := WindowMenuClick;
//RC9
     //         
     for ShortCutCount := 1 to 10 do //       "1"   "0"
      begin
       if ShortCutCount < 10 then  NewItemShortCutStr := IntToStr( ShortCutCount )//           
                             else  NewItemShortCutStr := '0'; //        0

       for MenuItemCount := 0 to WindowsItem.Count-1 do  //           Windows1
        if ShortCutToText( WindowsItem.Items[MenuItemCount].ShortCut ) = NewItemShortCutStr then NewItemShortCutStr := ''; //      ()       

       if ( NewItemShortCutStr <> '' ) //           
         and
          ( ShortCutToText( WindowMenuItem.ShortCut ) = '') //          
          then
           WindowMenuItem.ShortCut := TextToShortCut( NewItemShortCutStr ); //         
      end;
    end;
  end;
end;
//        - Files\Open
procedure TMainForm.OpenFileClick(Sender: TObject);
begin
 if (OpenDialog1.Execute) and (FileExists(OpenDialog1.FileName)) then //        
  begin
   OpenFiles.Add(OpenDialog1.FileName);
   OpenFile( OpenDialog1.FileName );
  end;
end;
//        - View\Font\Bold
//   4             
//              ,
//             
procedure TMainForm.BoldFontClick(Sender: TObject);
begin
 if ActiveMDIChild <> nil then //        
  with TViewForm(ActiveMDIChild) do //      (       Z- ) 
    RichEdit1.Font.Style := RichEdit1.Font.Style + [fsBold]; //         RichEdit - 
end;
//        - View\Font\Normal
//   TMainForm.Bold1Click        
procedure TMainForm.NormalFontClick(Sender: TObject);
begin
 if ActiveMDIChild <> nil then
  with TViewForm(ActiveMDIChild) do RichEdit1.Font.Style := []; //      RichEdit
end;
//         - View\Font\Italic
//   TMainForm.Bold1Click        
procedure TMainForm.ItalicFontClick(Sender: TObject);
begin
 if ActiveMDIChild <> nil then
  with TViewForm(ActiveMDIChild) do RichEdit1.Font.Style := RichEdit1.Font.Style + [fsItalic]; //      RichEdit - 
end;
//        - View\Font\Underline
//   TMainForm.Bold1Click        
procedure TMainForm.UnderlineFontClick(Sender: TObject);
begin
 if ActiveMDIChild <> nil then
  with TViewForm(ActiveMDIChild) do RichEdit1.Font.Style := RichEdit1.Font.Style + [fsUnderline]; //      RichEdit - 
end;
//        - File\Exit
procedure TMainForm.ExitRabbitClick(Sender: TObject);
begin
 MainForm.Close; //   ,     
end;
procedure TMainForm.SelectEngineClick(Sender: TObject);
begin
 Speech1.SelectEngine( ComboBox1.Text ); //   ,       ComboBox1 Text
 UsingReadAlgoritm := ComboBox2.ItemIndex+1;
 UsingDictionary   := CheckBox1.Checked;
 Button1.Enabled := false;
end;
//        - File\Close
procedure TMainForm.CloseFileClick(Sender: TObject);
begin
 if ActiveMDIChild <> nil then
  with TViewForm(ActiveMDIChild) do Close;  //    
end;
//        - View\WordWrap    
procedure TMainForm.WordWrapTextClick(Sender: TObject);
begin
 if ActiveMDIChild <> nil then
  begin
   WordWrapTextItem.Checked := not(  WordWrapTextItem.Checked ); //       

   with TViewForm(ActiveMDIChild) do
    RichEdit1.WordWrap := WordWrapTextItem.Checked; //        
                                             //  RichEdit1.WordWrap -     .
  end;
end;
//        View\Font\SizeUP
procedure TMainForm.SizeUpFontClick(Sender: TObject);
begin
 if ActiveMDIChild <> nil then
  with TViewForm(ActiveMDIChild) do RichEdit1.Font.Size :=  RichEdit1.Font.Size + 1; //      RichEdit    
end;
//        - View\Font\Size Down
procedure TMainForm.SizeDownFontClick(Sender: TObject);
begin
 if ActiveMDIChild <> nil then
  with TViewForm(ActiveMDIChild) do RichEdit1.Font.Size :=  RichEdit1.Font.Size - 1; //     RichEdit    
end;
//        - Help\About
procedure TMainForm.AboutRabbitClick(Sender: TObject);
begin
 About.AboutForm.ShowModal;
end;
//!read        Speech\Read
procedure TMainForm.ReadTextClick(Sender: TObject);
begin
 StopButton.Enabled := true;
 if ActiveMDIChild <> nil then
  with TViewForm(ActiveMDIChild) do begin
   StopReadText.Enabled := true;
   PauseReadText.Enabled := true;
   ReadText.Enabled := false;
   StatusBar1.Panels[0].Text := ssRead; //    StatusBar
   if Speech1.Paused
     then begin
       Speech1.Resume;//   
       end //then
     else
      begin

        StartReadText;
       end;//else
   end;//with
end;//procedure
//      Speech\Pause
procedure TMainForm.PauseTextClick(Sender: TObject);
begin
 if not( Speech1.Paused )  //      
   then begin
     StopReadText.Enabled := true;// 
     PauseReadText.Enabled := false;// 
     ReadText.Enabled := true;// 
     StatusBar1.Panels[0].Text := ssPause; //     
     Speech1.Pause; //    
     end//then
   else begin//,     
     StopReadText.Enabled := true;// 
     PauseReadText.Enabled := false;// 
     ReadText.Enabled := true;// 
     StatusBar1.Panels[0].Text := ssPause; //     
     end//else
end;//procedure
//         - Speech\Stop
procedure TMainForm.StopTextClick(Sender: TObject);
begin
  AbortReading := true;
  Speech1.Stop; //    ,         
end;//procedure
//!event    SAPI,      
//        
procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
var
 WaitCount : integer;  //  
begin
  if AutoSave then
   begin
    SetMConf( 'MainWidth', IntToStr(Width));
    SetMConf( 'MainHeight', IntToStr(Height));
    SetMConf( 'MainTop', IntToStr(Top));
    SetMConf( 'MainLeft', IntToStr(Left));
    SetMConf('SpeechPanel',BoolToStr(Panel3.Visible));
    OpenFiles.SaveToFile(StartDir + '\' + ConfigFolder + '\' + 'opendocs.ini');

    SetMConf('SpeechSpeed', IntToStr(Speech1.Speed));
    SetMConf('SpeechVolume',IntToStr(Speech1.Volume));
    SetMConf('SpeechPitch',IntToStr(Speech1.Pitch));

   end;

//           
 AbortReading := true;
 Speech1.Stop; //  
//    ,   SAPI    
  WaitCount  := 0;
 repeat
  Application.ProcessMessages; //    ""                                                         
  inc(  WaitCount  );          //      (  WaitCount  :=   WaitCount  + 1 ):
  sleep(10);                   //   1\100 
 until  WaitCount  > 10;       //    1\100 
end;
//        ComboBox1   
procedure TMainForm.ComboBox1Change(Sender: TObject);
begin
 Button1.Enabled := true;
end;

procedure TMainForm.ComboBox2Change(Sender: TObject);
begin
 Button1.Enabled := true;
end;

procedure TMainForm.CheckBox1Change(Sender: TObject);
begin
 Button1.Enabled := true;
end;

//          
procedure TMainForm.SpeedUp1Click(Sender: TObject);
begin
 ScrollBar1.Position := ScrollBar1.Position + 10; //      ScrollBar1  10 
                                                  //   
end;
//          
procedure TMainForm.SpeedDown1Click(Sender: TObject);
begin
 ScrollBar1.Position := ScrollBar1.Position - 10; //      ScrollBar1  10 
                                                  //   
end;
//          
procedure TMainForm.VolumeUp1Click(Sender: TObject);
begin
 ScrollBar2.Position := ScrollBar2.Position + 10;
end;
//          
procedure TMainForm.VolumeDown1Click(Sender: TObject);
begin
 ScrollBar2.Position := ScrollBar2.Position - 10;
end;
//   
procedure TMainForm.PitchUp1Click(Sender: TObject);
begin
  ScrollBar3.Position := ScrollBar3.Position + 10;
end;
//   
procedure TMainForm.PitchDown1Click(Sender: TObject);
begin
   ScrollBar3.Position := ScrollBar3.Position - 10;
end;
// \   (Panel3),       ""   
procedure TMainForm.SpeechPanel1Click(Sender: TObject);
begin
 Panel3.Visible := not( Panel3.Visible ); //       ,     
                                          // Panel3.Visible     Panel3
 ToolButton7.Down := Panel3.Visible;
 ToolBar1.Align  := alTop;
end;
//      "" (ScrollBar1)
procedure TMainForm.ScrollBar1Change(Sender: TObject);
begin
 Speech1.Speed := ScrollBar1.Position; //     ,      ScrollBar1 
                                       //      Speech1.Info.MinSpeed  Speech1.Info.MaxSpeed
 Label5.Caption := InttoStr(Speech1.Speed);
 //speech1.speak(label1.caption+' '+label5.caption); // 
end;
//      "" (ScrollBar2)
//  ScrollBar1Change
procedure TMainForm.ScrollBar2Change(Sender: TObject);
begin
 Speech1.Volume := ScrollBar2.Position;
 Label6.Caption := InttoStr(Speech1.Volume);
 //speech1.speak(label2.caption+' '+label6.caption); // 
end;
//      "" (ScrollBar3)
procedure TMainForm.ScrollBar3Change(Sender: TObject);
begin                           
 Speech1.Pitch := ScrollBar3.Position;
 Label7.Caption := InttoStr(Speech1.Pitch);
 //speech1.speak(label3.caption+' '+label7.caption); // 
end;
//       RichEdit1  8
procedure TMainForm.Size81Click(Sender: TObject);
begin
 if ActiveMDIChild <> nil then
  with TViewForm(ActiveMDIChild) do RichEdit1.Font.Size := 8; //       8
end;
//       RichEdit1  12
procedure TMainForm.Size121Click(Sender: TObject);
begin
 if ActiveMDIChild <> nil then
  with TViewForm(ActiveMDIChild) do RichEdit1.Font.Size := 12;
end;
//       RichEdit1  14
procedure TMainForm.Size141Click(Sender: TObject);
begin
 if ActiveMDIChild <> nil then
  with TViewForm(ActiveMDIChild) do RichEdit1.Font.Size := 14;
end;
//       RichEdit1  18
procedure TMainForm.Size181Click(Sender: TObject);
begin
 if ActiveMDIChild <> nil then
  with TViewForm(ActiveMDIChild) do RichEdit1.Font.Size := 18;
end;
//      RichEdit1   24
procedure TMainForm.Size241Click(Sender: TObject);
begin
 if ActiveMDIChild <> nil then
  with TViewForm(ActiveMDIChild) do RichEdit1.Font.Size := 24;
end;
//      
procedure TMainForm.Normal2Click(Sender: TObject);
begin
 ScrollBar1.Position := Speech1.Info.MinSpeed + (Speech1.Info.MaxSpeed-Speech1.Info.MinSpeed) div 2; //    ScrollBar1
 //       ,      ScrollBar1Change      
 //        .
end;
//     
procedure TMainForm.Normal3Click(Sender: TObject);
begin
 ScrollBar2.Position := Speech1.Info.MinVolume + (Speech1.Info.MaxVolume-Speech1.Info.MinVolume) div 2; //    ScrollBar1

end;
//       Normal2Click
procedure TMainForm.Normal4Click(Sender: TObject);
begin
 ScrollBar3.Position := Speech1.Info.MinPitch + (Speech1.Info.MaxPitch-Speech1.Info.MinPitch) div 2; //    ScrollBar1
end;
//          "About".
//              ,
//       ,    
//      try -  except -  end;
procedure TMainForm.EngineDialogAboutClick(Sender: TObject);
begin
 try //    
  Speech1.ShowDialog( sdAbout ); //     
 except //  
  ShowMessage('select engine not support this dialog'); //      
 end; //   
end;
// see TMainForm.EngineDialogAboutClick
procedure TMainForm.EngineDialogLexiconClick(Sender: TObject);
begin
 try
  Speech1.ShowDialog( sdLexicon );
 except
  ShowMessage('select engine not support this dialog');
 end;
end;
// see TMainForm.EngineDialogAboutClick
procedure TMainForm.EngineDialogTranslateClick(Sender: TObject);
begin
 try
  Speech1.ShowDialog( sdTranslate );
 except
  ShowMessage('select engine not support this dialog');
 end;
end;
// see TMainForm.EngineDialogAboutClick
procedure TMainForm.EngineDialogGeneralClick(Sender: TObject);
begin
 try
  Speech1.ShowDialog( sdGeneral );
 except
  ShowMessage('select engine not support this dialog');
 end;
end;
//   FontDialog1   Windows 
//             
//    RichEdit1   
procedure TMainForm.FontDialog1Click(Sender: TObject);
begin
 if ActiveMDIChild <> nil then
  with TViewForm(ActiveMDIChild) do
   begin
    FontDialog1.Font.Assign(RichEdit1.Font);
    if FontDialog1.Execute then //          
      RichEdit1.Font.Assign( FontDialog1.Font ); //    RichEdit1       FontDialog1
   end;
end;
// see TMainForm.FontDialog1Click(Sender: TObject);
procedure TMainForm.ColorDialog1Click(Sender: TObject);
begin
 if ActiveMDIChild <> nil then
  with TViewForm(ActiveMDIChild) do
   begin
    ColorDialog1.Color := RichEdit1.Color;
    if ColorDialog1.Execute then RichEdit1.Color := ( ColorDialog1.Color );
  end;
end;
//        
procedure TMainForm.SpeechPanelTop1Click(Sender: TObject);
begin
 Panel3.Align := alTop;
end;
//        
procedure TMainForm.SpeechPanelBottomClick(Sender: TObject);
begin
  Panel3.Align := alBottom;
end;

procedure TMainForm.ShowDictonaryClick(Sender: TObject);
begin
 if DictionaryForm = nil then DictionaryForm := TDictionaryForm.Create(MainForm.Owner)
                         else DictionaryForm.Show;
end;

procedure TMainForm.ShowHint(Sender: TObject);
begin
  if Length(Application.Hint) > 0 then
  begin
    StatusBar1.SimplePanel := True;
    StatusBar1.SimpleText := Application.Hint;
  end
  else StatusBar1.SimplePanel := False;
end;

procedure TMainForm.SetDefaultClick(Sender: TObject);
begin
if ActiveMDIChild <> nil then
  with TViewForm(ActiveMDIChild) do
   begin
    SetMConf('rViewBgColor',ColorToString( RichEdit1.Color ));
    SetMConf('rViewWordWrap',BoolToStr(RichEdit1.WordWrap));
    SetMConf('rViewFont',RichEdit1.Font.Name);
    SetMConf('rViewFontSize',inttostr(RichEdit1.Font.Size ));
    SetMConf('rViewFontColor',ColorToString( RichEdit1.Font.Color ));
  end;
end;

procedure TMainForm.ChengLangClick(Sender: TObject);
var
 LCount : byte;
begin
 for LCount := 0 to LangItem.Count - 1 do
  begin
   if LangItem.Items[LCount].Checked then LangItem.Items[LCount].Checked := false;
   if TMenuItem(Sender).Caption = LangItem.Items[LCount].Caption then
    begin
     TMenuItem(Sender).Checked := true;
     CurentLang := LCount + 1;
     AdjustCaptions;
    end;
  end;
end;

procedure TMainForm.ShowHelpBook(Sender: TObject);
begin
 GetHelp('Main');
end;
procedure TMainForm.ShowWebSite(Sender: TObject);
begin
 ShellExecute( 0 , nil , 'http://wtwsoft.narod.ru/build.htm',nil,nil,SW_SHOWNORMAL);
end;

procedure TMainForm.LibraryAdd(Sender: TObject);
begin
 AddBookDialog.AddBookForm.ShowModal;
end;

procedure TMainForm.LibraryAddNew(Sender: TObject);
begin
 AddBookDialog.AddBookForm.ShowModal;
end;

procedure TMainForm.LibraryShow(Sender: TObject);
begin
 BookLibrary.ShowLibrary;
end;
//!start     ,         
procedure TMainForm.StartReadText;
begin
  if ActiveMDIChild <> nil then
    with TViewForm(ActiveMDIChild) do
     begin
      LoadDiction;
      if (RichEdit1.Text <> '')
         and
         (RichEdit1.SelStart < length(RichEdit1.Text))
        then
         begin
          LoadDiction;
          ReadingText;
        end;
     end;
end;

procedure TMainForm.ReadingText;
begin
  AbortReading := false;
  if ActiveMDIChild <> nil then
    with TViewForm(ActiveMDIChild) do
     begin
       s1 := RichEdit1.Text;
       s2 := '';
       i := RichEdit1.SelStart;
       Speech1StopEvent(nil);
    end;
end;

procedure TMainForm.Speech1StartEvent(Sender: TObject);
begin
  StopEnabled( true );
  PauseEnabled( true );
  StartEnabled( false );
  StatusBar1.Panels[0].Text := ssRead;
end;

procedure TMainForm.Speech1PauseEvent(Sender: TObject);
begin
 StopEnabled( true );
 PauseEnabled( false );
 StartEnabled( true );
 StatusBar1.Panels[0].Text := ssPause;
end;
//    SAPI,     
procedure TMainForm.Speech1StopEvent(Sender: TObject);
begin
        s := '';

        SymbolCount := 0;
         repeat
           Application.ProcessMessages;
           inc(i);
           inc(SymbolCount);
           s := s + s1[i];
         until
           ((( SymbolCount > 2500 )
            and(( s1[i] = '.' )or( s1[i] = '!' )
              or( s1[i] = '?' )or( s1[i] = ';' )))
           or ( i >= length( s1))or( SymbolCount > 2000 ))
           or ( AbortReading);

        // if UsingDictionary then s := FiltrText(s);
         s := FiltrText(s);
         Speech1.Speak(s);

{ if not( Speech1.Paused ) then  //    
  begin
   StopEnabled( false );
   PauseEnabled( false );
   StartEnabled( true );
   StatusBar1.Panels[0].Text := ssStop; //    StatusBar
  end
 else
  begin //    
   Speech1PauseEvent( Sender );
  end;}
end;
//    SAPI, ,  SAPI      
procedure TMainForm.Speech1ErrorEvent(Sender: TObject; Code: Integer;  Message: String);
begin
 StatusBar1.Panels[0].Text := Message; //    StatusBar
end;
//    SAPI, ,  SAPI       
procedure TMainForm.Speech1WarningEvent(Sender: TObject; Code: Integer;  Message: String);
begin
 StatusBar1.Panels[0].Text := Message; //    StatusBar
end;
//    SAPI,        
procedure TMainForm.Speech1VisualEvent(Sender: TObject; Hints: Cardinal; Mouth: PTTSMouth);
begin
//  ProgressBar1.Position := Mouth.bMouthHeight;
end;
// text reading position
procedure TMainForm.Timer1Timer(Sender: TObject);
begin
  if t <> Speech1.Position then
  begin
  with TViewForm(ActiveMDIChild) do
   begin
    RichEdit1.SelStart := t;
    RichEdit1.SelLength := Speech1.Position-t;
    RichEdit1.SelAttributes.Color := clblue;
    RichEdit1.SelLength := 0;
    RichEdit1.SelStart := Speech1.Position;
   end;
    t2 := t2 + Speech1.Position;
    t := Speech1.Position;
  end;
end;
//------------------------------------------------------------------------------
procedure TMainForm.StartEnabled( flag : boolean );
begin
 ReadButton.Enabled := flag;
 ReadText.Enabled   := flag;
end;
procedure TMainForm.PauseEnabled( flag : boolean );
begin
 PauseButton.Enabled := flag;
 PauseReadText.Enabled   := flag;
end;
procedure TMainForm.StopEnabled( flag : boolean );
begin
 StopButton.Enabled := flag;
 StopReadText.Enabled   := flag;
end;



procedure TMainForm.BitBtn1Click(Sender: TObject);
begin
  GetHelp('Rabbit II');
end;

end.
// Have a nice Windows ;)

