unit About;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids, ExtCtrls, ComCtrls, ShellAPI;

type
  TAboutForm = class(TForm)
    Bevel1: TBevel;
    StringGrid1: TStringGrid;
    Button1: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Image1: TImage;
    RichEdit1: TRichEdit;
    Label5: TLabel;
    Panel1: TPanel;
    procedure FormActivate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Label2Click(Sender: TObject);
    procedure StringGrid1SelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure StringGrid1DblClick(Sender: TObject);
  private
  public
  end;

var
  AboutForm: TAboutForm;
  SelCount: integer;
implementation
uses Main;
{$R *.dfm}

procedure TAboutForm.FormActivate(Sender: TObject);
begin

 Label3.Caption := 'Version: ' + RVersion;
 Label4.Caption := 'Build: ' + RBuild;

 StringGrid1.Cols[0].Clear;
 StringGrid1.Cols[1].Clear;
 StringGrid1.Cols[2].Clear;
 StringGrid1.RowCount := 2;


 StringGrid1.Cols[0].Add(' name ');
 StringGrid1.Cols[1].Add(' email ');
 StringGrid1.Cols[2].Add(' comment ');

 StringGrid1.Cols[0].Add('Konstantin');
 StringGrid1.Cols[1].Add('brul@brul.mbox.com.ua');
 StringGrid1.Cols[2].Add('testing');

 StringGrid1.RowCount := StringGrid1.RowCount+1;
 StringGrid1.Cols[0].Add('Andrey');
 StringGrid1.Cols[1].Add('tarakan@bk.ru');
 StringGrid1.Cols[2].Add('book library');

 StringGrid1.RowCount := StringGrid1.RowCount+1;
 StringGrid1.Cols[0].Add('Uriy');
 StringGrid1.Cols[1].Add('comzik@narod.ru');
 StringGrid1.Cols[2].Add('administrator');

 StringGrid1.RowCount := StringGrid1.RowCount+1;
 StringGrid1.Cols[0].Add('Igor');
 StringGrid1.Cols[1].Add('igor@wtworg.da.ru');
 StringGrid1.Cols[2].Add('view');

 StringGrid1.RowCount := StringGrid1.RowCount+1;
 StringGrid1.Cols[0].Add('Sergey');
 StringGrid1.Cols[1].Add('romen13@ukr.net');
 StringGrid1.Cols[2].Add('help');

 StringGrid1.RowCount := StringGrid1.RowCount+1;
 StringGrid1.Cols[0].Add('Denis');
 StringGrid1.Cols[1].Add('wtwsoft@narod.ru');
 StringGrid1.Cols[2].Add('main build');


end;

procedure TAboutForm.Button1Click(Sender: TObject);
begin
 Close;
end;

procedure TAboutForm.Label2Click(Sender: TObject);
begin
 ShellExecute(Handle,'','http://wtwsoft.narod.ru/build.htm','','',0);
end;

procedure TAboutForm.StringGrid1SelectCell(Sender: TObject; ACol,
  ARow: Integer; var CanSelect: Boolean);
begin
  SelCount := ARow;
end;

procedure TAboutForm.StringGrid1DblClick(Sender: TObject);
begin
 ShellExecute(Handle,'',PAnsiChar('mailto:'+StringGrid1.Cols[1][SelCount]),'','',0);
end;

end.
