//------------------------------------------------------------------------------
// Project Rabbit II Open Source FreeWare
//
// http://wtwsoft.narod.ru/build.htm
// original download from http://wtwsoft.narod.ru
// mailto: wtwsoft@narod.ru
//     
//------------------------------------------------------------------------------
//        Delphi 7
// TSAPI/TSAPI.BPL,  !compile_component.bat
//------------------------------------------------------------------------------
program Rabbit2;
uses
  Forms,
  Graphics,
  SysUtils,
  Main in 'Main.pas' {MainForm},
  View in 'View.pas' {ViewForm},
  Dictionary in 'Dictionary.pas' {DictionaryForm},
  config in 'Config.pas',
  Help in 'Help.pas',
  ScrollInd in 'ScrollInd.pas' {ScrollIndForm},
  BookLibrary in 'BookLibrary.pas' {LibraryForm},
  AddBookDialog in 'AddBookDialog.pas' {AddBookForm},
  NoSAPI in 'NoSAPI.pas' {NoSAPIForm},
  Service in 'Service.pas',
  AddDictionaryDialog in 'AddDictionaryDialog.pas' {AddDictionaryForm},
  SPEECH4 in 'SAPI\SPEECH4.PAS',
  SAPI4 in 'SAPI\sapi4.pas',
  SAPI5 in 'SAPI\SAPI5.pas',
  About in 'About.pas' {Form1};

{$R rabbit2.res} //      
//      ,        
procedure BeforeInit;
var
  LangStr   : string;
  LangCount : byte;
begin
  GetDir( 0, StartDir );  //   ,    , 
                          //  ,     Rabbit.     
                          //    StartDir
   //        ,        .
  AutoSave  := StrToBool(GetMConf('Autosave'));//  ,    
  //            \config\main.ini
  for LangCount := 1 to 20 do
   begin
    LangStr := GetMConf( 'Lang' + IntToStr( LangCount ));     //      
    if LangStr[1]<>'%' then LangFolder[LangCount] := LangStr; //    ,      
   end;
  CurentLang := StrToInt( GetMConf( 'InterfaceLang' ));       //    ,       ,
end;
// StartUp:
begin
  BeforeInit;
  Application.Initialize;
  Application.CreateForm(TMainForm, MainForm);
  Application.CreateForm(THelpForm, HelpForm);
  Application.CreateForm(TScrollIndForm, ScrollIndForm);
  Application.CreateForm(TAddBookForm, AddBookForm);
  Application.CreateForm(TNoSAPIForm, NoSAPIForm);
  Application.CreateForm(TAboutForm, AboutForm);
  MainForm.BuildMainForm;
  Application.Run;
end.
